#! /bin/sh

# Bootstrap this package from CVS.

# Copyright (C) 2003, 2004, 2005, 2006 Free Software Foundation, Inc.

# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2, or (at your option)
# any later version.

# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
# 02110-1301, USA.

# Written by Paul Eggert.

package=sed

# Translation Project URL, for the registry of all projects.
TP_URL='http://www.iro.umontreal.ca/translation/registry.cgi?domain='
TP_PO_URL='http://www.iro.umontreal.ca/translation/teams/PO/'

# Ensure file names are sorted consistently across platforms.
# Also, ensure diagnostics are in English, e.g., "wget --help" below.
LC_ALL=C
export LC_ALL

# Parse options.

for option
do
  case $option in
  --help)
    echo "$0: usage: $0 [--gnulib-srcdir=DIR] [--cvs-user=USERNAME] [--skip-po]"
    exit;;
  --gnulib-srcdir=*)
    GNULIB_SRCDIR=`expr "$option" : '--gnulib-srcdir=\(.*\)'`;;
  --cvs-user=*)
    CVS_USER=`expr "$option" : '--cvs-user=\(.*\)'`;;
  --skip-po)
    SKIP_PO=t;;
  *)
    echo >&2 "$0: $option: unknown option"
    exit 1;;
  esac
done

echo "$0: Bootstrapping CVS $package..."

cleanup_gnulib() {
  status=$?
  rm -fr gnulib
  exit $status
}

# Get gnulib files.

case ${GNULIB_SRCDIR--} in
-)
  if [ ! -d gnulib ]; then
    echo "$0: getting gnulib files..."

    case ${CVS_AUTH-pserver} in
    pserver)
      CVS_PREFIX=':pserver:anonymous@';;
    ssh)
      CVS_PREFIX="$CVS_USER${CVS_USER+@}";;
    *)
      echo "$0: $CVS_AUTH: Unknown CVS access method" >&2
      exit 1;;
    esac

    case $CVS_RSH in
    '') export CVS_RSH=ssh;;
    esac

    trap cleanup_gnulib 1 2 13 15

    cvs -z3 -q -d ${CVS_PREFIX}cvs.savannah.gnu.org:/cvsroot/gnulib co gnulib ||
      cleanup_gnulib

    trap - 1 2 13 15
  fi
  GNULIB_SRCDIR=gnulib
esac

gnulib_tool=$GNULIB_SRCDIR/gnulib-tool
test -x $gnulib_tool || exit

# $gnulib_tool --import --m4-base=build-aux --lib=libsed --no-changelog --makefile-name=gnulib.mk \
#    acl alloca getline getopt gettext memchr memcmp memmove \
#    mkstemp obstack regex stdbool strerror strverscmp unlocked-io verify

# Get translations.

get_translations() {
  subdir=$1
  domain=$2

  case $SKIP_PO in
  '')
    echo "$0: getting translations into $subdir for $domain..."
    (cd $subdir && rm -f *.gmo) &&

    $WGET_COMMAND -O "$subdir/$domain.html" "$TP_URL$domain" &&

    sed -n 's|.*"http://[^"]*/translation/teams/PO/\([^/"]*\)/'"$domain"'-\([^/"]*\)\.[^."]*\.po".*|\1.\2|p' <"$subdir/$domain.html" |
    sort -k 1,1 -k 2,2n -k2,2 -k3,3n -k3,3 -k4,4n -k4,4 -k5,5n -k5.5 |
    awk -F. '
      { if (lang && $1 != lang) print lang, ver }
      { lang = $1; ver = substr($0, index($0, ".") + 1) }
      END { if (lang) print lang, ver }
    ' | awk -v domain="$domain" -v subdir="$subdir" '
      {
        lang = $1
  
        # Same maintainer as sed, so this one is more up to date.
        if (lang == "it") next

        ver = $2
        printf "{ $WGET_COMMAND -O %s/%s.po '\'"$TP_PO_URL"'/%s/%s-%s.%s.po'\'' &&\n", subdir, lang, lang, domain, ver, lang
        printf "  msgfmt -c -o /dev/null %s/%s.po || {\n", subdir, lang
        printf "    echo >&2 '\'"$0"': omitting translation for %s'\''\n", lang
        printf "    rm -f %s/%s.po; }; } &&\n", subdir, lang
      }
      END { print ":" }
    ' | sh &&
    rm "$subdir/$domain.html"
    ;;
  esac

  set "$subdir"/*.po 
  if test "$1" != "$subdir/*.po"; then
    echo "$*" | sed 's|po/||g; s|\.po||g' >"$subdir/LINGUAS"
  fi
}

case `wget --help` in
*'--no-cache'*)
  no_cache='--no-cache';;
*'--cache=on/off'*)
  no_cache='--cache=off';;
*)
  no_cache='';;
esac

WGET_COMMAND="wget -nv $no_cache"
export WGET_COMMAND

get_translations po $package || exit

# Reconfigure, getting other files.

echo "$0: autopoint --force ..."
autopoint --force || exit

echo "$0: $gnulib_tool --import ..."
$gnulib_tool --import

# Make sure aclocal.m4 is not older than input files.
sleep 1

for command in \
  'aclocal --force -I build-aux' \
  'autoconf --force' \
  'autoheader --force' \
  'automake --add-missing --copy --force-missing';
do
  echo "$0: $command ..."
  $command || exit
done


echo "$0: done.  Now you can run './configure'."
